/// <reference types="bluebird" />
import * as Bluebird from 'bluebird';
import { Action, Dispatch } from 'pretur.redux';
import { Query, Synchronizer, Fetcher } from 'pretur.sync';
import Querier from './query/Querier';
import Set from './data/Set';
import Record from './data/Record';
import UniqueReducible from './UniqueReducible';
export default class Reactive<TSet extends Set<TRecord, T>, TRecord extends Record<T>, T> extends UniqueReducible {
    private reactiveSet;
    private reactiveQuerier;
    private reactviceInitialized;
    private reactiveCount;
    private buildFetcher;
    private autoRefreshDebounceTime;
    private autoRefreshTimerId;
    constructor(set: TSet | null, query: Query | null, buildFetcher?: (() => Fetcher) | null, autoRefreshDebounceTime?: number);
    readonly set: TSet;
    readonly querier: Querier;
    readonly initialized: boolean;
    readonly count: number;
    readonly valid: boolean;
    reduce(action: Action<any, any>): this;
    init(dispatch: Dispatch, fetcher: Fetcher): Bluebird<void>;
    initIfNeeded(dispatch: Dispatch, fetcher: Fetcher): void;
    refresh(dispatch: Dispatch, fetcher: Fetcher): Bluebird<void>;
    ensureValidity(dispatch: Dispatch): boolean;
    ensureValidityAndSync(dispatch: Dispatch, synchronizer: Synchronizer, autoDecay?: boolean, autoRefresh?: boolean): boolean;
    skipValidityAndSync(dispatch: Dispatch, synchronizer: Synchronizer, autoRefresh?: boolean): void;
    protected cloneOverride(clone: this): void;
    protected createInstance(): this;
}
