import { I18nBundle } from 'pretur.i18n';
import { Dispatch } from 'pretur.redux';
import { Synchronizer } from 'pretur.sync';
import StatusReporter from './StatusReporter';
declare abstract class Record<T> extends StatusReporter {
    private originalRecord;
    constructor(synchronized?: boolean);
    readonly original: this;
    readonly error: I18nBundle;
    clear(dispatch: Dispatch): void;
    setRemoved(): this;
    setUnremoved(): this;
    protected checkValidity(): boolean;
    protected cloneOverride(clone: this): void;
    abstract appendSynchronizationModels(synchronizer: Synchronizer): void;
    abstract buildInsertModel(): T;
    protected abstract validate(): I18nBundle;
    protected abstract validateFields(): boolean;
}
export default Record;
