"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var actions_1 = require("./actions");
var StatusReporter_1 = require("./StatusReporter");
var Record = (function (_super) {
    __extends(Record, _super);
    function Record(synchronized) {
        var _this = _super.call(this, synchronized) || this;
        _this.originalRecord = _this;
        return _this;
    }
    Object.defineProperty(Record.prototype, "original", {
        get: function () {
            return this.originalRecord;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Record.prototype, "error", {
        get: function () {
            return this.validate();
        },
        enumerable: true,
        configurable: true
    });
    Record.prototype.clear = function (dispatch) {
        dispatch(actions_1.CLAY_DATA_CLEAR.create.unicast(this.uniqueId));
    };
    Record.prototype.setRemoved = function () {
        if (this.statusInstance.removed) {
            return this;
        }
        var clone = this.originalRecord.clone();
        clone.statusInstance = this.statusInstance.setRemoved();
        return clone;
    };
    Record.prototype.setUnremoved = function () {
        if (!this.statusInstance.removed) {
            return this;
        }
        var clone = this.originalRecord.clone();
        clone.statusInstance = this.statusInstance.setUnremoved();
        return clone;
    };
    Record.prototype.checkValidity = function () {
        return !this.validate() && this.validateFields();
    };
    Record.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone.originalRecord = this.originalRecord;
    };
    return Record;
}(StatusReporter_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Record;
