/// <reference types="bluebird" />
import * as Bluebird from 'bluebird';
import { OrderedMap } from 'immutable';
import { Action, Dispatch } from 'pretur.redux';
import { Query, Synchronizer, Fetcher } from 'pretur.sync';
import StatusReporter from './StatusReporter';
import Record from './Record';
declare abstract class Set<TRecord extends Record<T>, T> extends StatusReporter {
    private originalSet;
    protected setItems: OrderedMap<number, TRecord>;
    constructor(items?: T[], synchronized?: boolean);
    readonly original: this;
    readonly items: OrderedMap<number, TRecord>;
    reduce(action: Action<any, any>): this;
    clear(dispatch: Dispatch): void;
    add(dispatch: Dispatch, values?: T): void;
    remove(dispatch: Dispatch, target: number): void;
    unremove(dispatch: Dispatch, target: number): void;
    refresh(dispatch: Dispatch, query: Query, fetcher: Fetcher): Bluebird<number | null>;
    sync(synchronizer: Synchronizer): void;
    appendSynchronizationModels(synchronizer: Synchronizer): void;
    buildInsertModel(): T[];
    protected checkValidity(): boolean;
    protected cloneOverride(clone: this): void;
    protected abstract constructItem(synchronized?: boolean, values?: T): TRecord;
}
export default Set;
