"use strict";
var Status = (function () {
    function Status(synchronized) {
        if (synchronized === void 0) { synchronized = false; }
        this.isSynchronized = synchronized;
        this.isModified = false;
        this.isRremoved = false;
        this.isFresh = !synchronized;
        this.isPending = false;
    }
    Object.defineProperty(Status.prototype, "synchronized", {
        get: function () {
            return this.isSynchronized;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Status.prototype, "fresh", {
        get: function () {
            return this.isFresh;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Status.prototype, "added", {
        get: function () {
            return !this.isSynchronized;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Status.prototype, "modified", {
        get: function () {
            return this.isModified;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Status.prototype, "removed", {
        get: function () {
            return this.isRremoved;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Status.prototype, "pending", {
        get: function () {
            return this.isPending;
        },
        enumerable: true,
        configurable: true
    });
    Status.prototype.setDecayed = function () {
        if (!this.isFresh) {
            return this;
        }
        var clone = this.clone();
        clone.isFresh = false;
        return clone;
    };
    Status.prototype.setModified = function () {
        if (this.isModified) {
            return this;
        }
        var clone = this.clone();
        clone.isModified = true;
        return clone;
    };
    Status.prototype.setUnmodified = function () {
        if (!this.isModified) {
            return this;
        }
        var clone = this.clone();
        clone.isModified = false;
        return clone;
    };
    Status.prototype.setRemoved = function () {
        if (this.isRremoved) {
            return this;
        }
        var clone = this.clone();
        clone.isRremoved = true;
        return clone;
    };
    Status.prototype.setUnremoved = function () {
        if (!this.isRremoved) {
            return this;
        }
        var clone = this.clone();
        clone.isRremoved = false;
        return clone;
    };
    Status.prototype.setPending = function () {
        if (this.isPending) {
            return this;
        }
        var clone = this.clone();
        clone.isPending = true;
        return clone;
    };
    Status.prototype.setReady = function () {
        if (!this.isPending) {
            return this;
        }
        var clone = this.clone();
        clone.isPending = false;
        return clone;
    };
    Status.prototype.clone = function () {
        var clone = new Status();
        clone.isSynchronized = this.isSynchronized;
        clone.isModified = this.isModified;
        clone.isRremoved = this.isRremoved;
        clone.isFresh = this.isFresh;
        clone.isPending = this.isPending;
        return clone;
    };
    return Status;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Status;
