"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var lodash_1 = require("lodash");
var actions_1 = require("./actions");
var UniqueReducible_1 = require("../UniqueReducible");
var Attributor = (function (_super) {
    __extends(Attributor, _super);
    function Attributor(attributes) {
        var _this = _super.call(this) || this;
        if (Array.isArray(attributes)) {
            _this.queryAttributes = attributes.slice();
        }
        else {
            _this.queryAttributes = [];
        }
        return _this;
    }
    Object.defineProperty(Attributor.prototype, "attributes", {
        get: function () {
            return this.queryAttributes;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Attributor.prototype, "plain", {
        get: function () {
            if (!Array.isArray(this.queryAttributes) || this.queryAttributes.length === 0) {
                return null;
            }
            return this.queryAttributes.slice();
        },
        enumerable: true,
        configurable: true
    });
    Attributor.prototype.reduce = function (action) {
        if (actions_1.CLAY_QUERY_SET_ATTRIBUTES.is(this.uniqueId, action) && action.payload) {
            if (lodash_1.isEqual(this.queryAttributes, action.payload)) {
                return this;
            }
            var clone = this.clone();
            clone.queryAttributes = action.payload;
            return clone;
        }
        return this;
    };
    Attributor.prototype.set = function (dispatch, attributes) {
        if (Array.isArray(attributes)) {
            dispatch(actions_1.CLAY_QUERY_SET_ATTRIBUTES.create.unicast(this.uniqueId, attributes.slice()));
        }
        else {
            dispatch(actions_1.CLAY_QUERY_SET_ATTRIBUTES.create.unicast(this.uniqueId, []));
        }
    };
    Attributor.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone.queryAttributes = this.queryAttributes;
    };
    Attributor.prototype.createInstance = function () {
        return new Attributor();
    };
    return Attributor;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Attributor;
