"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var immutable_1 = require("immutable");
var UniqueReducible_1 = require("../UniqueReducible");
var SubQuerier_1 = require("./SubQuerier");
var Includer = (function (_super) {
    __extends(Includer, _super);
    function Includer(include) {
        var _this = _super.call(this) || this;
        if (include) {
            var keys = Object.keys(include);
            _this.includedSubQueriers = immutable_1.Map(keys.map(function (alias) {
                if (typeof include[alias] === 'object' && include[alias] !== null) {
                    return [alias, new SubQuerier_1.default(include[alias])];
                }
                if (include[alias] === true) {
                    return [alias, true];
                }
                return null;
            }).filter(Boolean));
        }
        else {
            _this.includedSubQueriers = immutable_1.Map();
        }
        return _this;
    }
    Object.defineProperty(Includer.prototype, "subQueriers", {
        get: function () {
            return this.includedSubQueriers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Includer.prototype, "plain", {
        get: function () {
            if (this.includedSubQueriers.size === 0) {
                return null;
            }
            var include = {};
            this.includedSubQueriers.forEach(function (subQuerier, alias) {
                if (typeof alias === 'string') {
                    if (subQuerier instanceof SubQuerier_1.default) {
                        include[alias] = subQuerier.plain;
                    }
                    else if (subQuerier === true) {
                        include[alias] = true;
                    }
                }
            });
            return include;
        },
        enumerable: true,
        configurable: true
    });
    Includer.prototype.reduce = function (action) {
        var _this = this;
        var modified = false;
        var newSubQueriers = this.includedSubQueriers.withMutations(function (s) {
            _this.includedSubQueriers.forEach(function (subQuerier, alias) {
                if (typeof alias === 'string') {
                    if (subQuerier instanceof SubQuerier_1.default) {
                        var newSubQuerier = subQuerier.reduce(action);
                        if (newSubQuerier !== subQuerier) {
                            modified = true;
                            s.set(alias, newSubQuerier);
                        }
                    }
                }
            });
        });
        if (modified) {
            var clone = this.clone();
            clone.includedSubQueriers = newSubQueriers;
            return clone;
        }
        return this;
    };
    Includer.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone.includedSubQueriers = this.includedSubQueriers;
    };
    Includer.prototype.createInstance = function () {
        return new Includer();
    };
    return Includer;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Includer;
