"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var lodash_1 = require("lodash");
var UniqueReducible_1 = require("../UniqueReducible");
var actions_1 = require("./actions");
var Orderer = (function (_super) {
    __extends(Orderer, _super);
    function Orderer(order) {
        var _this = _super.call(this) || this;
        _this.queryOrderOrdering = 'NONE';
        if (order) {
            _this.queryOrderField = order.field;
            _this.queryOrderOrdering = order.ordering;
            _this.queryOrderChain = order.chain || undefined;
        }
        return _this;
    }
    Object.defineProperty(Orderer.prototype, "field", {
        get: function () {
            return this.queryOrderField;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Orderer.prototype, "ordering", {
        get: function () {
            return this.queryOrderOrdering;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Orderer.prototype, "chain", {
        get: function () {
            return this.queryOrderChain;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Orderer.prototype, "plain", {
        get: function () {
            if (!this.queryOrderField) {
                return null;
            }
            var order = {
                field: this.queryOrderField,
                ordering: this.queryOrderOrdering,
            };
            if (Array.isArray(this.queryOrderChain)) {
                order.chain = this.queryOrderChain.slice();
            }
            return order;
        },
        enumerable: true,
        configurable: true
    });
    Orderer.prototype.reduce = function (action) {
        if (actions_1.CLAY_QUERY_SET_ORDER.is(this.uniqueId, action) && action.payload) {
            if (this.queryOrderField === action.payload.field &&
                this.queryOrderOrdering === action.payload.ordering &&
                lodash_1.isEqual(this.queryOrderChain, action.payload.chain)) {
                return this;
            }
            var clone = this.clone();
            clone.queryOrderField = action.payload.field;
            clone.queryOrderOrdering = action.payload.ordering;
            clone.queryOrderChain = action.payload.chain || undefined;
            return clone;
        }
        return this;
    };
    Orderer.prototype.set = function (dispatch, field, ordering, chain) {
        if (typeof ordering !== 'string') {
            if (this.field !== field) {
                ordering = 'ASC';
            }
            else {
                switch (this.ordering) {
                    case 'NONE':
                        ordering = 'ASC';
                        break;
                    case 'ASC':
                        ordering = 'DESC';
                        break;
                    default:
                        ordering = 'NONE';
                        break;
                }
            }
        }
        dispatch(actions_1.CLAY_QUERY_SET_ORDER.create.unicast(this.uniqueId, { field: field, ordering: ordering, chain: chain }));
    };
    Orderer.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone.queryOrderField = this.queryOrderField;
        clone.queryOrderOrdering = this.queryOrderOrdering;
        clone.queryOrderChain = this.queryOrderChain;
    };
    Orderer.prototype.createInstance = function () {
        return new Orderer();
    };
    return Orderer;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Orderer;
