"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var actions_1 = require("./actions");
var UniqueReducible_1 = require("../UniqueReducible");
var Paginator = (function (_super) {
    __extends(Paginator, _super);
    function Paginator(pagination) {
        var _this = _super.call(this) || this;
        if (pagination) {
            _this.skipItems = pagination.skip;
            _this.takeItems = pagination.take;
        }
        return _this;
    }
    Object.defineProperty(Paginator.prototype, "skip", {
        get: function () {
            return this.skipItems || undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "take", {
        get: function () {
            return this.takeItems || undefined;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Paginator.prototype, "plain", {
        get: function () {
            if (typeof this.skipItems !== 'number' && typeof this.takeItems !== 'number') {
                return null;
            }
            var pagination = {};
            if (typeof this.skipItems === 'number') {
                pagination.skip = this.skipItems;
            }
            if (typeof this.takeItems === 'number') {
                pagination.take = this.takeItems;
            }
            return pagination;
        },
        enumerable: true,
        configurable: true
    });
    Paginator.prototype.reduce = function (action) {
        if (actions_1.CLAY_QUERY_SET_PAGINATION.is(this.uniqueId, action) && action.payload) {
            if (this.skipItems === action.payload.skip &&
                this.takeItems === action.payload.take) {
                return this;
            }
            var clone = this.clone();
            clone.skipItems = action.payload.skip;
            clone.takeItems = action.payload.take;
            return clone;
        }
        return this;
    };
    Paginator.prototype.set = function (dispatch, skip, take) {
        dispatch(actions_1.CLAY_QUERY_SET_PAGINATION.create.unicast(this.uniqueId, { skip: skip, take: take }));
    };
    Paginator.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone.skipItems = this.skipItems;
        clone.takeItems = this.takeItems;
    };
    Paginator.prototype.createInstance = function () {
        return new Paginator();
    };
    return Paginator;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Paginator;
