"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require("../UniqueReducible");
var Value_1 = require("../data/Value");
var Includer_1 = require("./Includer");
var Filterer_1 = require("./Filterer");
var Attributor_1 = require("./Attributor");
var SubQuerier = (function (_super) {
    __extends(SubQuerier, _super);
    function SubQuerier(subquery) {
        var _this = _super.call(this) || this;
        if (subquery === null) {
            return _this;
        }
        _this.subQueryIncluder = new Includer_1.default(subquery.include);
        _this.subQueryFilterer = new Filterer_1.default(subquery.filters);
        _this.subQueryAttributor = new Attributor_1.default(subquery.attributes);
        _this.subQueryRequired = new Value_1.default(null, true, !!subquery.required);
        return _this;
    }
    Object.defineProperty(SubQuerier.prototype, "includer", {
        get: function () {
            return this.subQueryIncluder;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "filterer", {
        get: function () {
            return this.subQueryFilterer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "attributor", {
        get: function () {
            return this.subQueryAttributor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "plain", {
        get: function () {
            var subquery = {};
            var include = this.subQueryIncluder.plain;
            if (include !== null) {
                subquery.include = include;
            }
            var filters = this.subQueryFilterer.plain;
            if (filters !== null) {
                subquery.filters = filters;
            }
            var attributes = this.subQueryAttributor.plain;
            if (attributes !== null) {
                subquery.attributes = attributes;
            }
            var required = this.subQueryRequired.value;
            if (required) {
                subquery.required = true;
            }
            return subquery;
        },
        enumerable: true,
        configurable: true
    });
    SubQuerier.prototype.reduce = function (action) {
        var includer = this.subQueryIncluder.reduce(action);
        var filterer = this.subQueryFilterer.reduce(action);
        var attributor = this.subQueryAttributor.reduce(action);
        var required = this.subQueryRequired.reduce(action);
        if (includer !== this.subQueryIncluder ||
            filterer !== this.subQueryFilterer ||
            attributor !== this.subQueryAttributor ||
            required !== this.subQueryRequired) {
            var clone = this.clone();
            clone.subQueryIncluder = includer;
            clone.subQueryFilterer = filterer;
            clone.subQueryAttributor = attributor;
            clone.subQueryRequired = required;
            return clone;
        }
        return this;
    };
    SubQuerier.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone.subQueryIncluder = this.subQueryIncluder;
        clone.subQueryFilterer = this.subQueryFilterer;
        clone.subQueryAttributor = this.subQueryAttributor;
        clone.subQueryRequired = this.subQueryRequired;
    };
    SubQuerier.prototype.createInstance = function () {
        return new SubQuerier(null);
    };
    return SubQuerier;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = SubQuerier;
